# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.AppState.V1.Model.ListResponse do
  @moduledoc """
  This is a JSON template to convert a list-response for app state.

  ## Attributes

  - items (List[GetResponse]): The app state data. Defaults to: `null`.
  - kind (String): Uniquely identifies the type of this resource. Value is always the fixed string appstate#listResponse. Defaults to: `null`.
  - maximumKeyCount (Integer): The maximum number of keys allowed for this user. Defaults to: `null`.
  """

  defstruct [
    :"items",
    :"kind",
    :"maximumKeyCount"
  ]
end

defimpl Poison.Decoder, for: GoogleApi.AppState.V1.Model.ListResponse do
  import GoogleApi.AppState.V1.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:"items", :list, GoogleApi.AppState.V1.Model.GetResponse, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AppState.V1.Model.ListResponse do
  def encode(value, options) do
    GoogleApi.AppState.V1.Deserializer.serialize_non_nil(value, options)
  end
end

